diff --git b/misc/test-other.sh a/misc/test-other.sh
new file mode 100755
index 0000000..d20591a
--- /dev/null
+++ a/misc/test-other.sh
@@ -0,0 +1,223 @@
+#!/bin/sh
+
+# Additional make check test
+# check other tools (like Perl and PHP)
+# odbc MUST be configured to point to source driver
+
+# stop on errors
+set -e
+
+verbose=no
+do_perl=no
+do_php=yes
+
+# check for perl existence
+if perl -e 'exit 0' > /dev/null 2>&1; then
+	do_perl=yes
+fi
+
+for param
+do
+	case $param in
+	--verbose)
+		verbose=yes ;;
+	--no-perl)
+		do_perl=no ;;
+	--no-php)
+		do_php=no ;;
+	--perl-only)
+		do_perl=yes
+		do_php=no
+		;;
+	--php-only)
+		do_perl=no
+		do_php=yes
+		;;
+	*)
+		echo 'Option not supported!' 1>&2
+		exit 1
+		;;
+	esac
+done
+
+log () {
+        echo "@!@!@!@!@!@!@!@!@!@!@!@!@!@!@!@- $1 -@!@!@!@!@!@!@!@!@!@!@!@!@!@!@!@"
+}
+
+# set correct directory
+DIR=`dirname $0`
+cd "$DIR/.."
+
+# save directory
+ORIGDIR="$PWD"
+
+# init log
+LOG="$PWD/test-other.log"
+rm -f "$LOG"
+echo "log started" >> "$LOG"
+
+## assure make
+#make all
+#echo "make all ok" >> "$LOG"
+
+tUID=`cat PWD | grep '^UID=' | sed 's,^....,,g'`
+tPWD=`cat PWD | grep '^PWD=' | sed 's,^....,,g'`
+tSRV=`cat PWD | grep '^SRV=' | sed 's,^....,,g'`
+tDB=`cat PWD | grep '^DB=' | sed 's,^...,,g'`
+
+# prepare odbc.ini redirection
+rm -f odbc.ini
+for f in .libs/libtdsodbc.so .libs/libtdsodbc.sl .libs/libtdsodbc.dll .libs/libtdsodbc.dylib; do
+	if test -r "$PWD/src/odbc/$f"; then
+		echo "[$tSRV]
+Driver = $PWD/src/odbc/$f
+Database = $tDB
+Servername = $tSRV
+
+[xx_$tSRV]
+Driver = $PWD/src/odbc/$f
+Database = $tDB
+Servername = $tSRV" > odbc.ini
+		ODBCINI="$PWD/odbc.ini"
+		SYSODBCINI="$PWD/odbc.ini"
+		export ODBCINI SYSODBCINI
+		break;
+	fi
+done
+
+# Perl
+if test $do_perl = yes; then
+	DBI_DSN="dbi:ODBC:$tSRV"
+	DBI_USER="$tUID"
+	DBI_PASS="$tPWD"
+	export DBI_DSN DBI_USER DBI_PASS
+	# TODO better way
+	ODBCHOME=/usr
+	export ODBCHOME
+	for f in DBD-ODBC-*.tar.gz; do
+		DIR=`echo "$f" | sed s,.tar.gz$,,g`
+		echo Testing $DIR
+		if ! test -d "$DIR"; then
+			tar zxvf "$DIR.tar.gz"
+			# try to apply patch for Sybase
+			cd "$DIR"
+			{ patch -p1 || true ; } <<EOF
+diff -ru DBD-ODBC-1.13/t/07bind.t DBD-ODBC-1.13my/t/07bind.t
+--- DBD-ODBC-1.13/t/07bind.t	2005-02-20 10:09:17.039561424 +0100
++++ DBD-ODBC-1.13my/t/07bind.t	2004-12-18 15:19:11.000000000 +0100
+@@ -133,7 +133,7 @@
+ 		  # expect!
+ 		  \$row[2] = "";
+ 	       }
+-	       if (\$row[2] ne \$_->[2]) {
++	       if (\$row[2] ne \$_->[2] && (\$dbname ne "sql server" || \$row[2] ne " ") ) {
+ 		  print "Column C value failed! bind value = \$bind_val, returned values = \$row[0]|\$row[1]|\$row[2]|\$row[3]\\n";
+ 		  return undef;
+ 	       }
+EOF
+			# fix for DBD::ODBC and Perl 5.8.8
+			echo "--- DBD-ODBC-1.13.orig/dbdimp.c	2004-11-05 04:19:36.000000000 +0100
++++ DBD-ODBC-1.13/dbdimp.c	2007-01-16 09:38:20.477774620 +0100
+@@ -2921,11 +2921,11 @@
+     * */
+    else if (is_inout != phs->is_inout) {
+       croak(\"Can't rebind or change param %s in/out mode after first bind (%d => %d)\",
+ 	    phs->name, phs->is_inout, is_inout);
+    }
+-   else if (maxlen && maxlen != phs->maxlen) {
++   else if (maxlen && maxlen > phs->maxlen) {
+       croak(\"Can't change param %s maxlen (%ld->%ld) after first bind\",
+ 	    phs->name, phs->maxlen, maxlen);
+    }
+ 
+    if (!is_inout) {    /* normal bind to take a (new) copy of current value    */
+" | patch -p1 || true
+			cd t
+			{ patch -p0 || true ; }  <<EOF
+--- 20SqlServer.t.orig  2005-08-09 13:33:30.000000000 +0200
++++ 20SqlServer.t       2005-08-09 13:37:36.000000000 +0200
+@@ -419,7 +419,7 @@
+
+    \$dbh->{odbc_async_exec} = 1;
+    # print "odbc_async_exec is: \$dbh->{odbc_async_exec}\\n";
+-   is(\$dbh->{odbc_async_exec}, 1, "test odbc_async_exec attribute set");
++   is(\$dbh->{odbc_async_exec}, 0, "test odbc_async_exec attribute NOT set");
+
+    # not sure if this should be a test.  May have permissions problems, but it's the only sample
+    # of the error handler stuff I have.
+EOF
+			cd ../..
+		fi
+		test -d "$DIR"
+		cd "$DIR"
+		grep -v 'prompt(' Makefile.PL > Makefile.PL.tmp
+		cat Makefile.PL.tmp > Makefile.PL
+		test -r Makefile || LANG=C perl Makefile.PL
+		LANG=C make clean
+		RES=0
+		log "START DBD::ODBC make"
+		test -r Makefile || LANG=C classifier perl Makefile.PL || RES=$?
+		if test $RES = 0; then
+			LANG=C classifier make || RES=$?
+		fi
+		log "RESULT $RES"
+		log "END DBD::ODBC make"
+		if test $RES = 0; then
+			log "START DBD::ODBC test"
+			if test $verbose = yes; then
+				LANG=C classifier make test TEST_VERBOSE=1 || RES=$?
+			else
+				LANG=C classifier make test || RES=$?
+			fi
+			log "RESULT $RES"
+			log "END DBD::ODBC test"
+		fi
+		if test $RES != 0; then
+			exit $RES
+		fi
+	done
+fi
+
+# PHP
+cd "$ORIGDIR"
+FILE='php5.2-latest.tar.bz2'
+if test $do_php = yes -a -f "$FILE"; then
+	# need to recompile ??
+	if test ! -x phpinst/bin/php -o "$FILE" -nt phpinst/bin/php; then
+		rm -rf php5.2-200* phpinst lib
+		bunzip2 -c "$FILE" | tar xvf -
+		DIR=`echo php5.2-200*`
+		MAINDIR=$PWD
+		mkdir lib
+		cp src/dblib/.libs/lib*.s[ol]* lib
+		cp src/tds/.libs/libtds.a lib
+#		cp src/tds/.libs/lib*.s[ol]* lib
+		cd $DIR
+		CFLAGS='-O0 -pipe' ./configure --prefix=$MAINDIR/phpinst --disable-all --with-mssql=$MAINDIR  --with-unixODBC=/usr
+		make -j4
+		make install
+		cd ..
+	fi
+
+	cd phptests
+	echo "<?php \$server = \"$tSRV\"; \$user = \"$tUID\"; \$pass = \"$tPWD\"; ?>" > pwd.inc
+
+	ERR=""
+	for f in *.php; do
+		echo Testing PHP script $f
+		log "START PHP test $f"
+		RES=0
+		../phpinst/bin/php -q $f 2>&1 || { RES=$?; ERR="$ERR $f"; }
+		log "RESULT $RES"
+		log "FILE $PWD/$f"
+		log "END PHP test $f"
+	done
+	if test "$ERR" != ""; then
+		echo "Some script failed:$ERR"
+		exit 1
+	fi
+fi
+
+echo "all tests ok!!!" >> "$LOG"
+exit 0
+
diff --git b/mkinstalldirs a/mkinstalldirs
index ce6c2d3..4d8662b 100755
--- b/mkinstalldirs
+++ a/mkinstalldirs
@@ -4,7 +4,7 @@
 # Created: 1993-05-16
 # Public domain
 
-# $Id: mkinstalldirs,v 1.1.1.1 2001/10/12 23:28:53 brianb Exp $
+# $Id: mkinstalldirs,v 1.1 2001/10/12 23:28:53 brianb Exp $
 
 errstatus=0
 
diff --git b/phptests/.cvsignore a/phptests/.cvsignore
new file mode 100644
index 0000000..03a7a33
--- /dev/null
+++ a/phptests/.cvsignore
@@ -0,0 +1 @@
+pwd.inc
diff --git b/samples/.cvsignore a/samples/.cvsignore
new file mode 100644
index 0000000..f24dd77
--- /dev/null
+++ a/samples/.cvsignore
@@ -0,0 +1,3 @@
+Makefile
+Makefile.in
+unixodbc.freetds.driver.template
diff --git b/samples/odbc_rpc.pl a/samples/odbc_rpc.pl
new file mode 100755
index 0000000..cc93942
--- /dev/null
+++ a/samples/odbc_rpc.pl
@@ -0,0 +1,123 @@
+#!/usr/local/bin/perl
+# $Id: odbc_rpc.pl,v 1.7 2006/07/27 19:24:42 jklowden Exp $
+#
+# Contributed by James K. Lowden and is hereby placed in 
+# the public domain.  No rights reserved.  
+#
+# This program demonstrates calling the ODBC "dynamic" functions, using
+# placeholders and prepared statements.  
+#
+# By default, arguments are bound to type SQL_VARCHAR.  If the stored procedure 
+# uses other types, they may be specified in the form :TYPE:data, where TYPE is one
+# of the DBI symbolic constants.  If your data happen to begin with a colon, 
+# prefix the string with ':SQL_VARCHAR:'.  
+#
+# Example: a datetime parameter:  ':SQL_DATETIME:2005-04-01 16:46:00' 
+# (Unfortunately, it appears DBD::ODBC has difficulty with SQL_DATETIME:
+# http://www.opensubscriber.com/message/perl-win32-users@listserv.ActiveState.com/108164.html
+#	
+#
+# To find the symbolic constants for DBI, perldoc DBI recommends:
+#  	use DBI;         
+#  	foreach (@{ $DBI::EXPORT_TAGS{sql_types} }) {
+#             printf "%s=%d\n", $_, &{"DBI::$_"};
+#  	}
+# 
+
+use DBI qw(:sql_types);
+use Getopt::Std;
+use File::Basename;
+
+# Stolen shamelessly from DBI: testerrhandler.pl
+
+sub err_handler {
+   my ($state, $msg) = @_;
+   # Strip out all of the driver ID stuff
+   $msg =~ s/^(\[[\w\s]*\])+//;
+   print "===> state: $state msg: $msg\n";
+   return 0;
+}
+
+sub setup_error_handler($)
+{ my ($dbh) = @_;
+
+	$dbh->{odbc_err_handler} = \&err_handler;
+	$dbh->{odbc_async_exec} = 1;
+	print "odbc_async_exec is: $dbh->{odbc_async_exec}\n";
+}
+
+$program = basename($0);
+
+Getopt::Std::getopts('U:P:D:d:h', \%opts);
+
+my ($dsn, $user, $pass, $database);
+$dsn  = $opts{D}? $opts{D} : "dbi:ODBC:JDBC";
+$user = $opts{U}? $opts{U} : 'guest';
+$pass = $opts{P}? $opts{P} : 'sybase';
+
+die qq(Syntax: \t$program [-D dsn] [-U username] [-P password] procedure [arg1[, argn]]\n) 
+	if( $opts{h} || 0 == @ARGV );
+
+# Connect
+my $dbh = DBI->connect($dsn, $user, $pass, {RaiseError => 0, PrintError => 1, AutoCommit => 1})
+	or die "Unable for connect to $dsn $DBI::errstr";
+
+setup_error_handler($dbh);
+
+# Construct an odbc placeholder list like (?, ?, ?)
+# for any arguments after $ARGV[0]. 
+my $placeholders = '';
+if( @ARGV > 1 ) {
+	my @placeholders = ('?') x (@ARGV - 1); 
+	$placeholders = '(' . join( q(, ),  @placeholders ) . ')';
+	printf STDERR qq(%d arguments found for procedure "$ARGV[0]"\n), scalar(@placeholders);
+}
+
+# Ready the odbc call
+my $sql = "{? = call $ARGV[0] $placeholders}";
+my $sth = $dbh->prepare( $sql );
+
+# Bind the return code as "inout".
+my $rc;
+print STDERR qq(Binding parameter #1, the return code\n);
+$sth->bind_param_inout(1, \$rc, SQL_INTEGER);
+
+# Bind the input parameters (we don't do outputs in this example).
+# Placeholder numbers are 1-based; the first "parameter" 
+# is the return code, $rc, above.
+for( my $i=1; $i < @ARGV; $i++ ) {
+    my $type = SQL_VARCHAR;
+    my $typename = 'SQL_VARCHAR';
+    my $data = $ARGV[$i];
+    if( $data =~ /^:([[:upper:]_]+):(.+)/ ) { # parse out the datatype, if any
+	$typename = $1;
+	$data = $2;
+        $type = eval($typename);
+	warn qq("$typename" will probably cause a "can't rebind parameter" message\n) 
+		if $type == SQL_DATETIME;
+    }
+    printf STDERR qq(Binding parameter #%d (%s): "$data"\n), ($i+1), $typename;
+    $sth->bind_param( 1 + $i, $data, $type );
+}
+
+print STDERR qq(\nExecuting: "$sth->{Statement}" with parameters '), 
+	     join(q(', '), @ARGV[1..$#ARGV]), qq('\n);
+
+# Execute the SQL and print the (possibly several) results
+$rc = $sth->execute;
+print STDERR qq(execute returned: '$rc'\n) if $rc;
+
+$i = 1;
+while ( $sth->{Active} ) { 
+	printf "Result #%d:\n", $i++;
+        my @names = @{$sth->{NAME}};	# print column names for each result set
+	print '[', join("], [", @{$sth->{NAME}}), "]\n" if @names;
+	while(@dat = $sth->fetchrow_array) {
+		print q('), join(q(', '), @dat), qq('\n);
+	}
+}
+
+$dbh->disconnect();
+
+exit 0;
+
diff --git b/src/.cvsignore a/src/.cvsignore
new file mode 100644
index 0000000..282522d
--- /dev/null
+++ a/src/.cvsignore
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
diff --git b/src/apps/.cvsignore a/src/apps/.cvsignore
new file mode 100644
index 0000000..36f7973
--- /dev/null
+++ a/src/apps/.cvsignore
@@ -0,0 +1,11 @@
+Makefile
+Makefile.in
+tsql
+freebcp
+bsqldb
+defncopy
+.libs
+.deps
+datacopy
+bsqlodbc
+
diff --git b/src/apps/fisql/.cvsignore a/src/apps/fisql/.cvsignore
new file mode 100644
index 0000000..ecef2f6
--- /dev/null
+++ a/src/apps/fisql/.cvsignore
@@ -0,0 +1,5 @@
+Makefile
+Makefile.in
+.libs
+.deps
+fisql
diff --git b/src/ctlib/.cvsignore a/src/ctlib/.cvsignore
new file mode 100644
index 0000000..aee705c
--- /dev/null
+++ a/src/ctlib/.cvsignore
@@ -0,0 +1,6 @@
+Makefile
+Makefile.in
+.libs
+*.lo
+*.la
+.deps
diff --git b/src/ctlib/unittests/.cvsignore a/src/ctlib/unittests/.cvsignore
new file mode 100644
index 0000000..4682152
--- /dev/null
+++ a/src/ctlib/unittests/.cvsignore
@@ -0,0 +1,34 @@
+Makefile
+Makefile.in
+.deps
+.libs
+t0001
+t0002
+t0003
+t0004
+t0005
+t0006
+t0007
+t0008
+t0009
+connect_fail
+tdsdump.out
+ct_options
+rpc_ct_setparam
+rpc_ct_param
+lang_ct_param
+get_send_data
+cs_diag
+array_bind
+ct_diagall
+ct_diagclient
+ct_diagserver
+cs_config
+cancel
+blk_in
+blk_out
+ct_cursor
+ct_cursors
+ct_dynamic
+blk_in2
+
diff --git b/src/dblib/.cvsignore a/src/dblib/.cvsignore
new file mode 100644
index 0000000..aee705c
--- /dev/null
+++ a/src/dblib/.cvsignore
@@ -0,0 +1,6 @@
+Makefile
+Makefile.in
+.libs
+*.lo
+*.la
+.deps
diff --git b/src/dblib/unittests/.cvsignore a/src/dblib/unittests/.cvsignore
new file mode 100644
index 0000000..691f42b
--- /dev/null
+++ a/src/dblib/unittests/.cvsignore
@@ -0,0 +1,48 @@
+Makefile
+Makefile.in
+.deps
+.libs
+t0001
+t0002
+t0003
+t0004
+t0005
+t0006
+t0007
+t0008
+t0009
+t0011
+t0012
+t0013
+t0013.out
+t0014
+t0014.out
+t0015
+t0016
+t0016.out
+t0017
+t0018
+t0019
+t0020
+t0021
+t0022
+tdsdump.out
+t0023
+t0016.err
+t0017.err
+t0017.out
+rpc
+dbmorecmds
+bcp
+thread
+text_buffer
+done_handling
+timeout
+dblib.dsw
+dblib.mak
+vc6
+hang
+null
+null2
+setnull
+
diff --git b/src/odbc/.cvsignore a/src/odbc/.cvsignore
new file mode 100644
index 0000000..c9a04fd
--- /dev/null
+++ a/src/odbc/.cvsignore
@@ -0,0 +1,7 @@
+Makefile
+Makefile.in
+.libs
+.deps
+*.lo
+*.la
+
diff --git b/src/odbc/checkexport.sh a/src/odbc/checkexport.sh
new file mode 100755
index 0000000..142cd4e
--- /dev/null
+++ a/src/odbc/checkexport.sh
@@ -0,0 +1,10 @@
+#!/bin/sh
+echo Function not exported by VMS driver
+(nm .libs/libtdsodbc.so | grep ' T ' | sed 's,.* T ,,g' | grep '^\(SQL\|ODBC\)'; cat ../../vms/odbc_driver_axp.opt | grep -v '^!' | grep 'SQL' | sed 's,.*SQL\(.*\)=PROCEDURE.*,SQL\1,g') | sort | uniq -u | grep -v ODBCINSTGetProperties
+
+echo Function not exported by windows driver
+(nm .libs/libtdsodbc.so | grep ' T ' | sed 's,.* T ,,g' | grep '^\(SQL\|ODBC\)'; cat ../../win32/FreeTDS.def | grep -v '^;' | grep 'SQL' | sed 's,.*SQL,SQL,g' | perl -pe 's,\r,,g') | sort | uniq -u | grep -v ODBCINSTGetProperties
+
+echo Function not declared as implemented
+(nm .libs/libtdsodbc.so | grep ' T ' | sed 's,.* T ,,g' | grep '^SQL' | perl -pe 'tr/a-z/A-Z/'; cat odbc.c | grep 'X(SQL_API_' | sed 's,.*SQL_API_SQL,SQL,g; s,).*,,g' | sort | uniq) | sort | uniq -u
+(nm .libs/libtdsodbc.so | grep ' T ' | sed 's,.* T ,,g' | grep '^SQL' | perl -pe 'tr/a-z/A-Z/'; cat odbc.c | grep '_(SQL_API_' | sed 's,.*SQL_API_SQL,SQL,g; s,).*,,g' | sort | uniq) | sort | uniq -d
diff --git b/src/odbc/unittests/.cvsignore a/src/odbc/unittests/.cvsignore
new file mode 100644
index 0000000..2da9b2c
--- /dev/null
+++ a/src/odbc/unittests/.cvsignore
@@ -0,0 +1,67 @@
+.libs
+Makefile
+Makefile.in
+t0001
+t0002
+t0003
+t0004
+tdsdump.out
+.deps
+connect
+print
+date
+norowset
+funccall
+lang_error
+tables
+binary_test
+moreandcount
+earlybind
+putdata
+params
+raiserror
+getdata
+type
+genparams
+transaction
+preperror
+odbc.ini
+odbcinst.ini
+prepare_results
+data
+testodbc
+error
+rebindpar
+convert_error
+typeinfo
+const_params
+compute
+insert_speed
+timeout
+array
+array_out
+cursor1
+cursor2
+scroll
+describecol
+copydesc
+msvc.mak
+prepclose
+warning
+paramcore
+rpc
+timeout2
+timeout3
+odbc.dsw
+odbc.mak
+vc6
+connect2
+timeout4
+freeclose
+cursor3
+cursor4
+cursor5
+attributes
+hidden
+blob1
+rowset
diff --git b/src/odbc/unittests/rownumber.c a/src/odbc/unittests/rownumber.c
new file mode 100644
index 0000000..d2c213f
--- /dev/null
+++ a/src/odbc/unittests/rownumber.c
@@ -0,0 +1,110 @@
+#include "common.h"
+
+/* Test for SQL_ATTR_ROW_NUMBER */
+
+/*
+ * This works under MS ODBC however I don't know if it's correct... 
+ * TODO make it work and add to Makefile.am
+ */
+
+static char software_version[] = "$Id: rownumber.c,v 1.2 2005/01/14 15:03:12 freddy77 Exp $";
+static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
+
+static void
+CheckRowNum(int n, int line)
+{
+	SQLRETURN res;
+	SQLUINTEGER value;
+
+	res = SQLGetStmtAttr(Statement, SQL_ATTR_ROW_NUMBER, &value, sizeof(value), NULL);
+	if (res != SQL_SUCCESS) {
+		if (res == SQL_ERROR && n < 0)
+			return;
+		ODBC_REPORT_ERROR("SQLGetStmtAttr failed");
+	}
+	if (value != n) {
+		fprintf(stderr, "Expected %d rows returned %d line %d\n", n, (int) value, line);
+		exit(1);
+	}
+}
+
+#undef CHECK_ROWS
+#define CHECK_ROWS(n) CheckRowNum(n,__LINE__)
+
+static void
+NextResults(SQLRETURN expected)
+{
+	if (SQLMoreResults(Statement) != expected) {
+		if (expected == SQL_SUCCESS)
+			fprintf(stderr, "Expected another recordset\n");
+		else
+			fprintf(stderr, "Not expected another recordset\n");
+		exit(1);
+	}
+}
+
+static void
+Fetch(SQLRETURN expected)
+{
+	if (SQLFetch(Statement) != expected) {
+		if (expected == SQL_SUCCESS)
+			fprintf(stderr, "Expected another record\n");
+		else
+			fprintf(stderr, "Not expected another record\n");
+		exit(1);
+	}
+}
+
+static void
+DoTest()
+{
+	int n = 0;
+	static const char query[] = "SELECT * FROM #tmp1 ORDER BY i SELECT * FROM #tmp1 WHERE i < 3 ORDER BY i";
+
+	/* execute a batch command and check row number */
+	if (SQLExecDirect(Statement, (SQLCHAR *) query, SQL_NTS) != SQL_SUCCESS)
+		ODBC_REPORT_ERROR("Unable to execute direct statement");
+	CHECK_ROWS(-1);
+	printf("Result %d\n", ++n);
+	Fetch(SQL_SUCCESS);
+	CHECK_ROWS(0);
+	Fetch(SQL_SUCCESS);
+	CHECK_ROWS(0);
+	Fetch(SQL_SUCCESS);
+	CHECK_ROWS(0);
+	Fetch(SQL_NO_DATA);
+	CHECK_ROWS(-1);
+	NextResults(SQL_SUCCESS);
+	CHECK_ROWS(-1);
+
+	printf("Result %d\n", ++n);
+	Fetch(SQL_SUCCESS);
+	CHECK_ROWS(0);
+	Fetch(SQL_SUCCESS);
+	CHECK_ROWS(0);
+	Fetch(SQL_NO_DATA);
+	CHECK_ROWS(-1);
+	NextResults(SQL_NO_DATA);
+	CHECK_ROWS(-1);
+}
+
+int
+main(int argc, char *argv[])
+{
+	use_odbc_version3 = 1;
+
+	Connect();
+
+	Command(Statement, "create table #tmp1 (i int)");
+	Command(Statement, "create table #tmp2 (i int)");
+	Command(Statement, "insert into #tmp1 values(1)");
+	Command(Statement, "insert into #tmp1 values(2)");
+	Command(Statement, "insert into #tmp1 values(5)");
+
+	DoTest();
+
+	Disconnect();
+
+	printf("Done.\n");
+	return 0;
+}
diff --git b/src/pool/.cvsignore a/src/pool/.cvsignore
new file mode 100644
index 0000000..7cdd226
--- /dev/null
+++ a/src/pool/.cvsignore
@@ -0,0 +1,5 @@
+Makefile
+Makefile.in
+.deps
+.libs
+tdspool
diff --git b/src/pool/stream.c a/src/pool/stream.c
new file mode 100644
index 0000000..8823cd9
--- /dev/null
+++ a/src/pool/stream.c
@@ -0,0 +1,455 @@
+/* TDSPool - Connection pooling for TDS based databases
+ * Copyright (C) 2001, 2002, 2003, 2004, 2005  Brian Bruns
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+/*
+ * Name: stream.c
+ * Description: Controls the result stream processing.
+ */
+
+#if HAVE_CONFIG_H
+#include <config.h>
+#endif /* HAVE_CONFIG_H */
+
+#include <stdarg.h>
+#include <stdio.h>
+
+#if HAVE_STDLIB_H
+#include <stdlib.h>
+#endif /* HAVE_STDLIB_H */
+
+#if HAVE_STRING_H
+#include <string.h>
+#endif /* HAVE_STDLIB_H */
+
+#include "pool.h"
+#include "tds.h"
+
+TDS_RCSID(var, "$Id: stream.c,v 1.25 2007/06/19 13:31:34 freddy77 Exp $");
+
+int pool_find_end_token(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int len);
+
+struct tmp_col_struct
+{
+	char *column_name;
+	struct tmp_col_struct *next;
+};
+
+/*
+ *  returns 1 if this end token has the final bit set
+ */
+static int
+is_final_token(const unsigned char *buf)
+{
+	return buf[1] & 0x01 ? 0 : 1;
+}
+
+/*
+ *  computes the number of bytes left to be read from the input stream 
+ *  after this packet is completely processed.
+ *  returns 1 if token overruns the current packet, 0 otherwise.
+ */
+static int
+bytes_left(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int pos, int maxlen, int need)
+{
+	if (pos + need > maxlen) {
+		return 1;
+	} else
+		return 0;
+}
+
+/*
+ * attempts to read a fixed length token, returns 1 if successful
+ * bytes_read is set to the number of bytes read fromt the input stream.
+ */
+static int
+read_fixed_token(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int maxlen, int *bytes_read)
+{
+	TDS_SMALLINT sz;
+	int marker;
+	int pos = 0;
+
+	if (bytes_left(pmbr, buf, pos, maxlen, 1)) {
+		*bytes_read = maxlen;
+		return 0;
+	}
+	marker = buf[pos++];
+	sz = tds_get_token_size(marker);
+	if (bytes_left(pmbr, buf, pos, maxlen, sz)) {
+		*bytes_read = maxlen;
+		return 0;
+	} else {
+		*bytes_read = sz + 1;
+		return 1;
+	}
+}
+
+static int
+read_variable_token(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int maxlen, int *bytes_read)
+{
+	TDS_SMALLINT sz;
+	int pos = 0;
+
+	if (bytes_left(pmbr, buf, pos, maxlen, 3)) {
+		*bytes_read = maxlen;
+		return 0;
+	}
+
+	/* memcpy(&sz,&buf[1],2); */
+	/* FIX ME -- works only in emul little endian mode on bigend boxen */
+	sz = buf[1] + buf[2] * 256;
+	pos += 3;
+	if (bytes_left(pmbr, buf, pos, maxlen, sz)) {
+		*bytes_read = maxlen;
+		return 0;
+	} else {
+		*bytes_read = sz + 3;
+		return 1;
+	}
+}
+
+static int
+read_row(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int maxlen, int *bytes_read)
+{
+	TDSCOLUMN *curcol;
+	TDSRESULTINFO *info;
+	int i, colsize;
+	int pos = 1;		/* skip marker */
+
+	info = pmbr->tds->res_info;
+
+	die_if((!info), "Entered read_row() without a res_info structure.");
+
+	for (i = 0; i < info->num_cols; i++) {
+		curcol = info->columns[i];
+		if (!is_fixed_type(curcol->column_type)) {
+			if (bytes_left(pmbr, buf, pos, maxlen, 1)) {
+				*bytes_read = maxlen;
+				return 0;
+			}
+			colsize = buf[pos++];
+		} else {
+			colsize = tds_get_size_by_type(curcol->column_type);
+		}
+		if (bytes_left(pmbr, buf, pos, maxlen, colsize)) {
+			*bytes_read = maxlen;
+			return 0;
+		}
+		pos += colsize;
+	}
+
+	*bytes_read = pos;
+
+	return 1;
+}
+
+static int
+read_col_name(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int maxlen, int *bytes_read)
+{
+	TDS_SMALLINT hdrsize;
+	int pos = 0;
+	int stop = 0, num_cols = 0;
+	int namelen;
+	struct tmp_col_struct *head = NULL, *cur = NULL, *prev;
+	int col;
+	TDSCOLUMN *curcol;
+	TDSRESULTINFO *info;
+
+	/* header size */
+	if (bytes_left(pmbr, buf, pos, maxlen, 3)) {
+		*bytes_read = maxlen;
+		return 0;
+	}
+	/* FIX ME -- endian */
+	hdrsize = buf[1] + buf[2] * 256;
+	pos += 3;
+
+	while (!stop) {
+		prev = cur;
+		cur = (struct tmp_col_struct *)
+			malloc(sizeof(struct tmp_col_struct));
+		if (prev)
+			prev->next = cur;
+		if (!head)
+			head = cur;
+
+		if (bytes_left(pmbr, buf, pos, maxlen, 1)) {
+			*bytes_read = maxlen;
+			return 0;
+		}
+		namelen = buf[pos++];
+
+
+		if (bytes_left(pmbr, buf, pos, maxlen, namelen)) {
+			*bytes_read = maxlen;
+			return 0;
+		}
+		cur->column_name = (char *) malloc(namelen + 1);
+		strncpy(cur->column_name, (char *) &buf[pos], namelen);
+		cur->column_name[namelen] = '\0';
+		cur->next = NULL;
+
+		pos += namelen;
+
+		num_cols++;
+
+		if (pos >= hdrsize)
+			stop = 1;
+	}
+
+	tds_free_all_results(pmbr->tds);
+	pmbr->tds->res_info = tds_alloc_results(num_cols);
+	info = pmbr->tds->res_info;
+
+	cur = head;
+
+	for (col = 0; col < info->num_cols; col++) {
+		curcol = info->columns[col];
+		strncpy(curcol->column_name, cur->column_name, sizeof(curcol->column_name));
+		/* FIXME ucs2 client and others */
+		curcol->column_name[sizeof(curcol->column_name) - 1] = 0;
+		curcol->column_namelen = strlen(curcol->column_name);
+		prev = cur;
+		cur = cur->next;
+		free(prev->column_name);
+		free(prev);
+	}
+
+
+	*bytes_read = pos;
+	return 1;
+}
+
+static int
+read_col_info(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int maxlen, int *bytes_read)
+{
+	TDS_SMALLINT hdrsize;
+	int pos = 0;
+	int col, rest;
+	TDSCOLUMN *curcol;
+	TDSRESULTINFO *info;
+	TDSSOCKET *tds = pmbr->tds;
+
+	/* header size */
+	if (bytes_left(pmbr, buf, pos, maxlen, 3)) {
+		*bytes_read = maxlen;
+		return 0;
+	}
+	/* FIX ME -- endian */
+	hdrsize = buf[1] + buf[2] * 256;
+	pos += 3;
+
+	info = tds->res_info;
+	for (col = 0; col < info->num_cols; col++) {
+		curcol = info->columns[col];
+		if (bytes_left(pmbr, buf, pos, maxlen, 5)) {
+			*bytes_read = maxlen;
+			return 0;
+		}
+		pos += 4;
+		curcol->column_type = buf[pos++];
+
+		/* FIX ME -- blob types */
+		if (!is_fixed_type(curcol->column_type)) {
+			if (bytes_left(pmbr, buf, pos, maxlen, 1)) {
+				*bytes_read = maxlen;
+				return 0;
+			}
+			curcol->column_size = buf[pos++];
+		} else {
+			curcol->column_size = tds_get_size_by_type(curcol->column_type);
+		}
+	}
+
+	rest = hdrsize + 3 - pos;
+	if (rest > 0) {
+		if (bytes_left(pmbr, buf, pos, maxlen, rest)) {
+			*bytes_read = maxlen;
+			return 0;
+		}
+		fprintf(stderr, "read_col_info: draining %d bytes\n", rest);
+		pos += rest;
+	}
+	*bytes_read = pos;
+
+	return 1;
+}
+
+/*
+ * TDS 5 style result sets
+ */
+static int
+read_result(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int maxlen, int *bytes_read)
+{
+	TDS_SMALLINT hdrsize;
+	int pos = 0;
+	int namelen;
+	int col;
+	TDSSOCKET *tds = pmbr->tds;
+	int num_cols;
+	TDSCOLUMN *curcol;
+	TDSRESULTINFO *info;
+
+	if (bytes_left(pmbr, buf, pos, maxlen, 3)) {
+		*bytes_read = maxlen;
+		return 0;
+	}
+	/* FIX ME -- endian */
+	hdrsize = buf[1] + buf[2] * 256;
+	pos += 3;
+
+	/* read number of columns and allocate the columns structure */
+	num_cols = buf[pos] + buf[pos+1] * 256;
+	pos += 2;
+
+	tds_free_all_results(tds);
+
+	tds->res_info = tds_alloc_results(num_cols);
+	info = pmbr->tds->res_info;
+
+	/*
+	 * loop through the columns populating COLINFO struct from
+ 	 * server response
+	 */
+
+	for (col = 0; col < info->num_cols; col++) {
+		curcol = info->columns[col];
+
+		namelen = buf[pos++];
+
+		strncpy(curcol->column_name, (char *) &buf[pos], namelen);
+		curcol->column_name[namelen] = '\0';
+		pos += namelen;
+
+		curcol->column_namelen = namelen;
+
+		pos++;     /* flags */
+		pos += 4;  /* user type */
+
+		tds_set_column_type(tds, curcol, (int)buf[pos]);
+		switch(curcol->column_varint_size) {
+			/* FIX ME - endian */
+			case 2: curcol->column_size = buf[pos] + buf[pos+1]*256; break;
+			case 1: curcol->column_size = buf[pos]; break;
+			case 0: break;
+		}
+		pos+=curcol->column_varint_size;
+		if (is_numeric_type(curcol->column_type))
+			pos+=2;
+
+		/* skip locale information */
+		pos += buf[pos];
+	}
+	return tds_alloc_row(info);
+}
+
+/* 
+ * is_end_token processes one token and returns 0 for an incomplete token
+ * or -1 if this is the END token, and 1 for successful processing of token.  
+ * The number of bytes read from the stream is returned in 'bytes_read'.
+ */
+static int
+pool_is_end_token(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int maxlen, int *bytes_read)
+{
+	TDS_SMALLINT sz;
+	int marker;
+	int ret;
+
+	if (maxlen == 0)
+		return 0;
+
+	marker = buf[0];
+	sz = tds_get_token_size(marker);
+
+	if (sz) {
+		ret = read_fixed_token(pmbr, buf, maxlen, bytes_read);
+	} else if (marker == TDS_ROW_TOKEN) {
+		ret = read_row(pmbr, buf, maxlen, bytes_read);
+	} else if (marker == TDS_COLNAME_TOKEN) {
+		ret = read_col_name(pmbr, buf, maxlen, bytes_read);
+	} else if (marker == TDS_COLFMT_TOKEN) {
+		ret = read_col_info(pmbr, buf, maxlen, bytes_read);
+	} else if (marker == TDS_RESULT_TOKEN) {
+		ret = read_result(pmbr, buf, maxlen, bytes_read);
+	} else {
+		ret = read_variable_token(pmbr, buf, maxlen, bytes_read);
+	}
+
+	/* fprintf(stderr,"bytes_read = %d\n",*bytes_read); */
+	if (!ret) {
+		return 0;
+	}
+
+	if (is_end_token(marker)) {
+		if (is_final_token(buf)) {
+			/* clean up */
+			return -1;
+		}
+	}
+
+	return 1;
+}
+
+int
+pool_find_end_token(TDS_POOL_MEMBER * pmbr, const unsigned char *buf, int len)
+{
+	int pos = 0, startpos, ret;
+	int bytes_read;
+	int stop = 0;
+	const unsigned char *curbuf;
+	unsigned char tmpbuf[PGSIZ + BLOCKSIZ];
+	int totlen;
+	static int last_mark;
+
+	/*
+	 * if we had part of a token left over, copy to tmpbuf
+	 */
+	if (pmbr->num_bytes_left) {
+		/* fprintf(stderr,"%d bytes left from last packet\n",pmbr->num_bytes_left); */
+		if (pmbr->num_bytes_left > 2000) {
+			fprintf(stderr, "marker is %d last mark was %d\n", pmbr->fragment[0], last_mark);
+		}
+		memcpy(tmpbuf, pmbr->fragment, pmbr->num_bytes_left);
+		memcpy(&tmpbuf[pmbr->num_bytes_left], buf, len);
+		curbuf = tmpbuf;
+		totlen = len + pmbr->num_bytes_left;
+	} else {
+		curbuf = buf;
+		totlen = len;
+	}
+
+	do {
+		startpos = pos;
+
+		ret = pool_is_end_token(pmbr, &curbuf[pos], totlen - pos, &bytes_read);
+		if (ret <= 0)
+			stop = 1;
+
+		pos += bytes_read;
+	} while (!stop);
+
+	if (ret == -1) {
+		pmbr->num_bytes_left = 0;
+		return 1;	/* found end token */
+	} else {
+		last_mark = buf[0];
+		pmbr->num_bytes_left = totlen - startpos;
+		memcpy(pmbr->fragment, &curbuf[startpos], pmbr->num_bytes_left);
+		return 0;	/* exhausted the stream */
+	}
+}
diff --git b/src/replacements/.cvsignore a/src/replacements/.cvsignore
new file mode 100644
index 0000000..aee705c
--- /dev/null
+++ a/src/replacements/.cvsignore
@@ -0,0 +1,6 @@
+Makefile
+Makefile.in
+.libs
+*.lo
+*.la
+.deps
diff --git b/src/server/.cvsignore a/src/server/.cvsignore
new file mode 100644
index 0000000..276eddd
--- /dev/null
+++ a/src/server/.cvsignore
@@ -0,0 +1,7 @@
+Makefile
+Makefile.in
+.libs
+*.lo
+*.la
+.deps
+tdssrv
diff --git b/src/tds/.cvsignore a/src/tds/.cvsignore
new file mode 100644
index 0000000..f9b4f83
--- /dev/null
+++ a/src/tds/.cvsignore
@@ -0,0 +1,11 @@
+Makefile
+Makefile.in
+.libs
+*.lo
+*.la
+.deps
+num_limits.h
+sybase_character_sets.h
+tds_willconvert.h
+encodings.h
+
